/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- config.h								--
--                                                                      --
--	Configuration vector						--
--                                                                      --
--	Author:  NHG 7/9/87						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: @(#)config.h	1.3	25/11/88 Copyright (C) 1987, Perihelion Software Ltd.	*/

#ifndef __config_h
#define __config_h

#ifndef __helios_h
#include <helios.h>
#endif

typedef struct LinkConf {
	byte	Flags;			/* initial flags		*/
	byte	Mode;			/* link mode			*/
	byte	State;			/* initial state		*/
	byte	Id;			/* link id			*/
} LinkConf;

typedef struct Config {
	word		PortTabSize;	/* # slots in port table	*/
	word		Incarnation;	/* what booter believes our incarnation is */
	word		*LoadBase;	/* address at which system was loaded */
	word		ImageSize;	/* size of system image		*/
	word		Date;		/* current system date		*/
	word		FirstProg;	/* offset of initial program	*/
	word		MemSize;	/* if > 0, size of RAM		*/
	word		Spare[2];	/* some spare slots		*/
	RPTR		MyName;		/* full path name		*/
	RPTR		ParentName;	/* ditto			*/
	word		NLinks;		/* number of links		*/
	LinkConf	LinkConf[4];	/* NLinks LinkConf structs 	*/
	/* name strings follow on from here */
} Config;

#ifdef in_kernel
#define GetConfig() ((Config *)(MinInt+0x200))
#endif

/* the LinkConf structures must be in the same order as the link	*/
/* channels in low memory.						*/


/* Image Vector */

#define IVecISize	0
#define IVecKernel	1
#define IVecSysLib	2
#define IVecServLib	3
#define IVecUtil	4
#define IVecBootStrap	5
#define IVecProcMan	6
#define IVecServers	7

#endif

/* -- End of config.h */
