
/* dirent.h : Posix Library directory entry header		*/

#ifndef _dirent_h
#define _dirent_h

#include <limits.h>

/* Directory entry structure, corresponds exactly to a Helios	*/
/* DirEntry structure. DO NOT ALTER.				*/
struct dirent
{
	long		d_type;
	long		d_flags;
	long		d_matrix;
	char		d_name[NAME_MAX+1];
};

#define DIRBUFSIZE	10

typedef struct _dirdesc
{
	int		dd_fd;
	long		dd_loc;
	long		dd_size;
	struct dirent	dd_buf[DIRBUFSIZE];
} DIR;

extern DIR *opendir(char *pathname);
extern struct dirent *readdir(DIR *dir);
extern void rewinddir(DIR *dir);
extern int closedir(DIR *dir);

#endif

/* end of dirent.h */
