/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- environ.h								--
--                                                                      --
--	Task environment defs						--
--                                                                      --
--	Author:  NHG 18/9/87						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: @(#)environ.h	1.2	25/11/88 Copyright (C) 1987, Perihelion Software Ltd.	*/

#ifndef __environ_h
#define __environ_h

#ifndef __helios_h
#include <helios.h>
#endif

#include <syslib.h>

/*----------------------------------------------------------------------*/
/* Environment description structure					*/
/*----------------------------------------------------------------------*/

typedef struct Environ {
	string		*Argv;		/* argument strings		*/
	string		*Envv;		/* environment strings		*/
	Object		**Objv;		/* objects to be passed		*/
	Stream		**Strv;		/* streams to be passed		*/
} Environ;

/*----------------------------------------------------------------------*/
/* Marshalled environment descriptors					*/
/*----------------------------------------------------------------------*/

typedef struct ObjDesc {
	Capability	Cap;		/* capability for object	*/
	char		Name[Variable];	/* object path name		*/
} ObjDesc;

typedef struct StrDesc {
	word		Mode;		/* mode stream was opened in	*/
	word		Pos;		/* position to start at		*/
	Capability	Cap;		/* capability for stream	*/
	char		Name[Variable];	/* name of stream object	*/
} StrDesc;

#endif

/* -- End of environ.h */
