
/* errno.h : Posix Library error numbers*/

/* WARNING: this file is generated automatically from the master codes*/
/* database, any changes here will be overwritten.*/


#ifndef __errno_h
#define __errno_h

#define E2BIG	1	/* Arg list too long */
#define EACCES	2	/* Permission denied */
#define EAGAIN	3	/* Resource temporarily unavailable */
#define EBADF	4	/* Bad file number */
#define EBUSY	5	/* Resource busy */
#define ECHILD	6	/* No child processes */
#define EDEADLK	7	/* Resource deadlock would occur */
#define EDOM	8	/* Domain error */
#define EEXIST	9	/* Already exists */
#define EFAULT	10	/* Bad address */
#define EFBIG	11	/* File too large */
#define EINTR	12	/* Interrupted system call */
#define EINVAL	13	/* Invalid argument */
#define EIO	14	/* Input/output error */
#define EISDIR	15	/* Wrong operation applied to directory */
#define EMFILE	16	/* Too many open files */
#define EMLINK	17	/* Too many links */
#define ENAMETOOLONG	18	/* Filename too long */
#define ENFILE	19	/* Too many open files in system */
#define ENODEV	20	/* No such device */
#define ENOENT	21	/* No such file or directory */
#define ENOEXEC	22	/* Exec format error */
#define ENOLCK	23	/* No locks available */
#define ENOMEM	24	/* Not enough memory space */
#define ENOSPC	25	/* No space left on device */
#define ENOTDIR	26	/* Not a directory */
#define ENOTEMPTY	27	/* Directory not empty */
#define ENOTTY	28	/* Inappropriate I/O operation */
#define ENXIO	29	/* No such device or address */
#define EPERM	30	/* Operation not permitted */
#define EPIPE	31	/* Broken pipe */
#ifndef ERANGE
#define ERANGE	32	/* Result too large */
#endif
#define EROFS	33	/* Read only file system */
#define ESPIPE	34	/* Invalid seek */
#define ESRCH	35	/* No such process */
#define EXDEV	36	/* Improper link */

#define MAX_PERROR 36          /* maximum posix error code */

#endif

/* end of errno.h*/

