
/* fcntl.h: Posix library file control header			*/

#ifndef _fcntl_h
#define _fcntl_h

/* Command values for fcntl()					*/

#define F_DUPFD		1	/* duplicate file descriptor	*/
#define F_GETFD		2	/* get file descriptor flags	*/
#define F_GETLK		3	/* get record locking info	*/
#define F_SETFD		4	/* set file descriptor flags	*/
#define F_GETFL		5	/* get file status flags	*/
#define F_SETFL		6	/* set file status flags	*/
#define F_SETLK		7	/* set record locking info	*/
#define F_SETLKW	8	/* set record locking info & wait*/


/* file access modes						*/

#define	O_RDONLY	0x0001
#define	O_WRONLY	0x0002
#define	O_RDWR		0x0003
#define	O_CREAT		0x0100
#define	O_EXCL		0x0200
#define	O_TRUNC		0x0400
#define O_NONBLOCK	0x0800
#define	O_APPEND	0x1000

#define O_ACCMODE	0x0003

/* file descriptor flags					*/

#define FD_CLOEXEC	0x8000	/* close file on exec();	*/


#endif

/* end of fcntl.h */
