#ifndef __ioevents_h
#define __ioevents_h
/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- ioevents.h								--
--                                                                      --
--		raw device events					--
--									--
--	Author:  BLV 08/02/88						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: 1.2	25/11/88 Copyright (C) 1987, Perihelion Software Ltd.	*/

/* These are valid types for the Type field of an Event */
#define Event_Mouse	0x1L
#define Event_Keyboard	0x2L
#define Event_Break	0x4L
#define Event_RS232Break 0x8L
#define Event_ModemRing  0x10L

#define Flag_Buffer	0x80000000L

/* additional reply codes */
#define EventRc_Acknowledge	0x1L   /* the other side should acknowledge   */
#define EventRc_IgnoreLost	0x2L   /* unimportant messages have been lost */


typedef struct { SHORT	X;
		 SHORT	Y;
		 WORD	Buttons;
} Mouse_Event;

#define Buttons_Unchanged	0x00000000L
#define Buttons_Button0_Down	0x00000001L
#define Buttons_Button0_Up	0x00008001L
#define Buttons_Button1_Down	0x00000002L
#define Buttons_Button1_Up	0x00008002L
#define Buttons_Button2_Down	0x00000004L
#define Buttons_Button2_Up	0x00008004L
#define Buttons_Button3_Down	0x00000008L
#define Buttons_Button3_Up	0x00008008L


typedef struct { WORD	Key;
		 WORD	What;
} Keyboard_Event;

#define Keys_KeyUp	1L
#define Keys_KeyDown	2L

typedef struct { WORD	junk1;
		 WORD	junk2;
} Break_Event;			/* this is for ctrl-C etc. */

typedef struct { WORD   junk1;
                 WORD   junk2;
} RS232Break_Event;

typedef struct { WORD   junk1;
                 WORD   junk2;
} ModemRing_Event;

typedef struct IOEvent {
	word Type;
	word Counter;
	word Stamp;
	union {
		Mouse_Event	 Mouse;
		Keyboard_Event	 Keyboard;
		Break_Event 	 Break;
                RS232Break_Event RS232Break;
                ModemRing_Event  ModemRing;
	} Device;
} IOEvent;

#endif

/* end of ioevents.h */
