
/* limits.h: ANSI draft (X3J11 Oct 86) library header, section 2.2.4.2 */
/* Copyright (C) A.C. Norman and A. Mycroft */
/* version 0.01 */

/* Expanded to incorporate POSIX limits; NHG 7/5/88 */

#ifndef __limits_h
#define __limits_h

#define CHAR_BIT 8
#define SCHAR_MIN (-128)
#define SCHAR_MAX 127
#define UCHAR_MAX 255
#define CHAR_MIN 0
#define CHAR_MAX 255

#define SHRT_MIN  (-0x8000)
#define SHRT_MAX  0x7fff
#define USHRT_MAX 65535U
#define INT_MIN   (~0x7fffffff)  /* -2147483648 and 0x80000000 are unsigned */
#define INT_MAX   0x7fffffff
#define UINT_MAX  0xffffffff
#define LONG_MIN  (~0x7fffffff)
#define LONG_MAX  0x7fffffff
#define ULONG_MAX 0xffffffffU

/* The following are for POSIX */

/* Note: some of these values are irrelevant to Helios, they are */
/* provided for completeness only and given their minimum values */

#define CLK_TCK		100
#define FCHR_MAX	ULONG_MAX
#define LINK_MAX	8
#define MAX_CHAR	256
#define NGROUPS_MAX	0
#define PASS_MAX	256
#define PID_MAX		INT_MAX
#define UID_MAX		32000

#define ARG_MAX		65535
#define MAX_CANON	256
#define NAME_MAX	31
#define PATH_MAX	512

#define	PIPE_BUF	512
#define PIPE_MAX	LONG_MAX

#define CHILD_MAX	LONG_MAX
#define CHILD_MAX_CEIL	CHILD_MAX
#define OPEN_MAX	LONG_MAX
#define OPEN_MAX_CEIL	OPEN_MAX


#endif

/* end of limits.h */
