/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   C   L I B R A R Y			--
--                     -------------------------------                  --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- nonansi.h								--
--                                                                      --
--	Helios extensions to the ANSI library				--
--                                                                      --
--	Author:  BLV 9/5/88						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: @(#)nonansi.h	1.3	7/4/89 Copyright (C) 1987, Perihelion Software Ltd.	*/

#ifndef __nonansi_h
#define __nonansi_h

#ifndef __syslib_h
#include <syslib.h>
#endif
#ifndef __memory_h
#include <memory.h>
#endif
#ifndef __stdio_h
#include <stdio.h>
#endif

void *NewProcess(WORD stacksize, VoidFnPtr function, WORD argsize);
void RunProcess(void *process);
void ZapProcess(void *process);
WORD Fork(WORD stacksize, VoidFnPtr function, WORD argsize, ...);
WORD _cputime(void);
void StackCheck(void);
void Accelerate(Carrier *fastram, VoidFnPtr function, WORD argsize, ...);
void AccelerateCode(VoidFnPtr function);
void IOdebug(const char *fmt, ...);
void IOputc(char c);
void IOputs(char *s);

extern Stream *fdstream(int);		/* POSIX fd -> Helios stream convert */
extern int fileno(FILE *);		/* Clib stream -> POSIX fd convert   */
extern FILE *fdopen(int, string);	/* POSIX fd -> Clib FILE * 	     */

/* This macro is for compatability */
#define Heliosno(s) fdstream(fileno(s))
#endif
