/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- protect.h								--
--                                                                      --
--	Protection data structures					--
--                                                                      --
--	Author:  NHG 18/9/87						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: @(#)protect.h	1.3	25/11/88 Copyright (C) 1987, Perihelion Software Ltd.	*/

#ifndef __protect_h
#define __protect_h

#ifndef __helios_h
#include <helios.h>
#endif


typedef unsigned long	Matrix;		/* access matrix		*/

typedef UBYTE		AccMask;	/* access mask			*/

typedef word		Key;		/* encryption key		*/

/*----------------------------------------------------------------------*/
/* Access capability 							*/
/*----------------------------------------------------------------------*/

typedef struct Capability {
	AccMask		Access;		/* access mask			*/
	UBYTE 		Valid[7];	/* validation value		*/
} Capability;

/*----------------------------------------------------------------------*/
/* Access mask bits 							*/
/*----------------------------------------------------------------------*/

#define AccMask_Full	0xff		/* all bits set			*/

/* All */
#define AccMask_R	0x01		/* Read permission		*/
#define AccMask_W	0x02		/* Write permission		*/
#define AccMask_D	0x40		/* Delete permission		*/
#define AccMask_A	0x80		/* Alter permission		*/

/* Files only */
#define AccMask_E	0x04		/* Execute permission		*/

/* Directories only */
#define AccMask_V	0x04		/* V access category		*/
#define AccMask_X	0x08		/* X access category		*/
#define AccMask_Y	0x10		/* Y access category		*/
#define AccMask_Z	0x20		/* Z access category		*/

/* Tasks only */
#define AccMask_K	AccMask_D	/* Kill task (== Delete)	*/

/*----------------------------------------------------------------------*/
/* Printed matrix letters						*/
/*----------------------------------------------------------------------*/

#define FileChars	"rwefghda"
#define DirChars	"rwvxyzda"
#define TaskChars	"rw????ka"
#define ModChars	"r?e???da"
#define ProgChars	"rwe???da"

/*----------------------------------------------------------------------*/
/* Default Matrices 							*/
/*----------------------------------------------------------------------*/

#define DefTFMatrix	0x21134BC7	/* darwv:drwx:rwy:rz		*/
#define DefTaskMatrix	0x010343C3	/* darw:drw:rw:r		*/
#define DefDirMatrix	0x21134BC7	/* darwv:drwx:rwy:rz		*/
#define DefFileMatrix	0x010343C3	/* darw:drw:rw:r		*/
#define DefModuleMatrix	0x010545C5	/* dare:dre:re:r		*/
#define DefProgMatrix	0x010541C5	/* dare:dre:re:r		*/

#endif

/* -- End of protect.h */
