/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- root.h								--
--                                                                      --
--	Root data structure						--
--                                                                      --
--	Author:  NHG 16/8/87						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: @(#)root.h	1.4	1/12/88 Copyright (C) 1987, Perihelion Software Ltd.	*/

#ifndef __root_h
#define __root_h

#ifndef __helios_h
#include <helios.h>
#endif

#include <queue.h>
#include <memory.h>
#include <link.h>
#include <sem.h>

#ifndef in_kernel
struct PTE { word secret; };		/* keep secret outside kernel	*/
#endif

typedef struct RootStruct {
        word    	Flags;		/* system flags			*/
        struct PTE	**PortTable;    /* pointer to port table	*/
        word    	PTSize;         /* number of ports in table	*/
        word    	PTFreeq;        /* port table free queue	*/
	LinkInfo	**Links;	/* pointer to link table	*/
	Pool		SysPool;	/* allocated system memory	*/
	Pool		*FreePool;	/* free memory list		*/
	word		Incarnation;	/* our incarnation number	*/
	List		BufferPool;	/* pending delivery buffer pool	*/
	word		BuffPoolSize;	/* number of free slots in pool	*/
	word		LoadAverage;	/* low pri load average		*/
	word		Latency;	/* hi pri scheduling latency	*/
	word		*TraceVec;	/* pointer to trace vector	*/
	List		EventList;	/* list of event routines	*/
	word		EventCount;	/* number of events seen	*/
	word		Time;		/* current system time (secs)	*/
	Pool		FastPool;	/* fast memory pool		*/
	word		MaxLatency;	/* maximum latency		*/
	Semaphore	IODebugLock;	/* lock for all IOdebugs	*/	
	word		MachineType;	/* processor type code		*/
	word		BufferCount;	/* number of kernel buffers used*/
	word		MaxBuffers;	/* max number of buffers allowed*/
	word		Timer;		/* system timer value (MHz)	*/
	char		Reserved[24];	/* bring up to 50 words.	*/
} RootStruct;

#define SysBase		0x80001000

#define GetRoot() ((RootStruct *)(SysBase+(int)(*((int *)SysBase))))

#endif

/* -- End of root.h */
