/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S   N U C L E U S                      --
--                     ---------------------------                      --
--                                                                      --
--             Copyright (C) 1987, Perihelion Software Ltd.             --
--                        All Rights Reserved.                          --
--                                                                      --
-- sem.h								--
--                                                                      --
--	Kernel semaphore support					--
--                                                                      --
--	Author:  NHG 16/8/87						--
--                                                                      --
------------------------------------------------------------------------*/
/* SccsId: @(#)sem.h	1.5	6/3/89 Copyright (C) 1987, Perihelion Software Ltd.	*/

#ifndef __sem_h
#define __sem_h

#ifndef __helios_h
#include <helios.h>
#endif

/* Semaphore structure */

#ifndef _ID_
#define _ID_
struct Id { word secret; };	/* secret to kernel			*/
#endif

typedef struct Semaphore {
        word		Count;		/* semaphore counter		*/
        struct Id	*Head;		/* head of process list		*/
        struct Id	*Tail;		/* tail of process list		*/
} Semaphore;


/* Kernel support routines */

PUBLIC void InitSemaphore(Semaphore *, word);
PUBLIC void Wait(Semaphore *);
PUBLIC void Signal(Semaphore *);
PUBLIC void SignalStop(Semaphore *);
PUBLIC word TestSemaphore(Semaphore *);

#endif

/* -- End of sem.h */
