/*----------------------------------------------------------------------------
--                                                                          --
--                         H E L I O S                                      --
--                         -----------                                      --
--                                                                          --
--             Copyright (C) 1987, Perihelion Software Ltd.                 --
--                        All Rights Reserved.                              --
--                                                                          --
--                                                                          --
--                                                                          --
------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- SUBSYSTEM NAME: NETWORK MANAGEMENT                                       --
--                                                                          --
-- TASK FORCE:  Session Manager                                             --
--                                                                          --
-- Header File For Session Management					    --
--                                                                          --
-- FILENAME: session.h                                                      --
--                                                                          --
-- AUTHOR: C.H.R.G                                                          --
--                                                                          --
-- DATE: 22:01:89                                                           --
--                                                                          --
----------------------------------------------------------------------------*/


/* User Data File Information */

#define   USERDATA_FILE "/helios/etc/passwd"




/* Session manager server names */

#define	  SM_NAME  "/sm"
#define	  SESSION  "/sm/users"
#define   USERDATA "/sm/userdata"



/* Private Error Message Functions */

/* Object Error Codes	*/

#define   ER_UserName	0x000000001	/* User Name		*/
#define   ER_Passwd	0x000000002	/* Password		*/
#define   ER_MaxUsers	0x000000003	/* Too many users	*/


typedef struct SessionInfo {
	char	TtyName[2*NameMax];/* terminal Identity		*/
	word	Duration;	/* required  Session duration 	*/
	word	RootDomain;	/* Could be used to set up a 	*/
				/* root domain for this session	*/
				
	char	UserName[NameMax];/* Username			*/
	char	Password[NameMax];/* User password		*/
	
} SessionInfo;




/* Session Environment */

typedef struct SessionEnv {
	
	Environ	Env;
	char	*Argv[10];
	char	*Envv[10];
	Object	*Objv[32];
	Stream  *Strv[32];
	
} SessionEnv;


/* Standard Offsets in Environment vector for various Shell variables */

#define  O_USER		0
#define  O_COMMENT	1
#define  O_HOME		2
#define  O_SHELL	3
#define  O_PATH		4
#define  O_TERM		5
#define  O_CONSOLE	6
#define  O_NULL		7




/* User Database Structure */

typedef struct UserData {
	
	char	UserName[NameMax];
	char	Password[NameMax];
	word	Uid;
	word	Gid;
	string	Comment;
	string  HomeDir;
	string	*ShellArgv;
	Object *RootAccess;
	word	RootDomain;
	Date	Duration;
} UserData;




