
/* termios.h : Posix library Terminal I/O control		*/

#ifndef _termios_h
#define _termios_h

#include <attrib.h>

#define NCCS	7

#define VEOF	0
#define VEOL	1
#define VERASE	2
#define VINTR	3
#define	VKILL	4
#define VQUIT	5
#define VSUSP	6

#define	VMIN	VEOF
#define VTIME	VEOL

/* defines for tcsetattr */
#define TCSANOW		1
#define TCSADRAIN	2
#define TCSADFLUSH	3

/* defines for tcflush */
#define	TCIFLUSH	1
#define TCOFLUSH	2
#define TCIOFLUSH	3

/* defines for tcflow	*/
#define	TCOOFF		1
#define TCOON		2
#define TCIOFF		4
#define TCION		8

/* This structure correseponds EXACTLY to a Helios Attributes strucuture */
struct termios {
	unsigned long	c_iflag;
	unsigned long	c_oflag;
	unsigned long	c_cflag;
	unsigned long	c_lflag;
	unsigned short	c_min;
	unsigned short	c_time;
	unsigned char	c_cc[NCCS];	/* MUST ADD THIS TO ATTRIBUTES */
};

extern int cf_getospeed(struct termios *t);
extern int cf_setospeed(struct termios *t, int speed);
extern int cf_getispeed(struct termios *t);
extern int cf_setispeed(struct termios *t, int speed);
extern int tcgetattr(int fd, struct termios *t);
extern int tcsetattr(int fd, int actions, struct termios *t);
extern int tcsendbreak(int fd, int duration);
extern int tcdrain(int fd);
extern int tcflush(int fd, int qselect);
extern int tcflow(int fd, int action);
extern int tcgetpgrp(int fd);
extern int tcsetpgrp(int fd, int pid);

#endif

/* end of termios.h */
